/* Les deux lignes suivantes sont la uniquement pour eviter 
   que mouvement.h soit inclus plusieurs fois. */
#ifndef _MOUVEMENT_H
#define _MOUVEMENT_H

/* Definition d'un type abstrait mouvement */
typedef struct mouvement_base* mouvement;

/*@ requires nothing;
    assigns nothing;
    ensures retourne un mouvement de orig vers dest; */
mouvement constr(int orig, int dest);

/*@ requires \valid(mouvement);
    assigns nothing;
    ensures retourne l'origine du mouvement; */
int orig(mouvement);

/*@ requires \valid(mouvement);
    assigns nothing;
    ensures retourne la destination du mouvement; */
int dest(mouvement);

#endif  /* mouvement.h */
