#include "file.h"
#include "mouvement.h"
#include <stdlib.h>

struct list {
  mouvement mouv;
  struct list* next;
};

typedef struct list* list;
  
struct file_base {
  list debut;
  list fin;
};


file file_vide() {
  file res = malloc(sizeof(struct file_base));
  res->debut = NULL;
  res->fin = NULL;
  return res;
}
  
  
int est_file_vide(file f) {
  return (f->debut == NULL);
}


mouvement defiler(file* f) {
  mouvement m = (*f)->debut->mouv;
  list l = (*f)->debut;
  (*f)->debut = (*f)->debut->next;
  free(l);
  return m;
}


void enfiler(file* f, mouvement m) {
  list l = malloc(sizeof(struct list));
  l->mouv = m;
  l->next = NULL;
  if ((*f)->debut) {
    (*f)->fin->next = l;
    (*f)->fin = l;
  } else {
    (*f)->debut = l;
    (*f)->fin = l;
  };
}
    

